OGRE: Ogre::SceneManager::Listener Class Reference - OGRE Documentation

# Ogre::SceneManager::Listener Class Reference

Class that allows listening in on the various stages of SceneManager processing, so that custom behaviour can be implemented from outside. More...

`#include <OgreSceneManager.h>`

List of all members.

## Public Member Functions
| Listener ()
virtual | ~Listener ()
virtual void | preFindVisibleObjects (SceneManager *source, IlluminationRenderStage irs, Viewport *v)=0
| Called prior to searching for visible objects in this SceneManager.
virtual void | postFindVisibleObjects (SceneManager *source, IlluminationRenderStage irs, Viewport *v)=0
| Called after searching for visible objects in this SceneManager.
virtual void | shadowTexturesUpdated (size_t numberOfShadowTextures)=0
| Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes).
virtual void | shadowTextureCasterPreViewProj (Light *light, Camera *camera, size_t iteration)=0
| This event occurs just before the view & projection matrices are set for rendering into a shadow texture.
virtual void | shadowTextureReceiverPreViewProj (Light *light, Frustum *frustum)=0
| This event occurs just before the view & projection matrices are set for re-rendering a shadow receiver.
virtual bool | sortLightsAffectingFrustum (LightList &lightList)
| Hook to allow the listener to override the ordering of lights for the entire frustum.

## Detailed Description

Class that allows listening in on the various stages of SceneManager processing, so that custom behaviour can be implemented from outside.

Definition at line 220 of file OgreSceneManager.h.

## Constructor & Destructor Documentation

Ogre::SceneManager::Listener::Listener | ( |  | ) |

Definition at line 223 of file OgreSceneManager.h.

virtual Ogre::SceneManager::Listener::~Listener | ( |  | ) | `[virtual]`

Definition at line 224 of file OgreSceneManager.h.

## Member Function Documentation

virtual void Ogre::SceneManager::Listener::preFindVisibleObjects | ( | SceneManager * | source,
|  | IlluminationRenderStage | irs,
|  | Viewport * | v |
| ) |  |  | `[pure virtual]`

Called prior to searching for visible objects in this SceneManager.

Remarks:
  Note that the render queue at this stage will be full of the last render's contents and will be cleared after this method is called.

Parameters:

  | source | The SceneManager instance raising this event.
  | irs | The stage of illumination being dealt with. IRS_NONE for a regular render, IRS_RENDER_TO_TEXTURE for a shadow caster render.
  | v | The viewport being updated. You can get the camera from here.

virtual void Ogre::SceneManager::Listener::postFindVisibleObjects | ( | SceneManager * | source,
|  | IlluminationRenderStage | irs,
|  | Viewport * | v |
| ) |  |  | `[pure virtual]`

Called after searching for visible objects in this SceneManager.

Remarks:
  Note that the render queue at this stage will be full of the current scenes contents, ready for rendering. You may manually add renderables to this queue if you wish.

Parameters:

  | source | The SceneManager instance raising this event.
  | irs | The stage of illumination being dealt with. IRS_NONE for a regular render, IRS_RENDER_TO_TEXTURE for a shadow caster render.
  | v | The viewport being updated. You can get the camera from here.

virtual void Ogre::SceneManager::Listener::shadowTexturesUpdated | ( | size_t | numberOfShadowTextures | ) | `[pure virtual]`

Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes).

Remarks:
  This callback is useful for those that wish to perform some additional processing on shadow textures before they are used to render shadows. For example you could perform some filtering by rendering the existing shadow textures into another alternative shadow texture with a shader.]

Note:
  This event will only be fired when texture shadows are in use.

Parameters:

  | numberOfShadowTextures | The number of shadow textures in use

virtual void Ogre::SceneManager::Listener::shadowTextureCasterPreViewProj | ( | Light * | light,
|  | Camera * | camera,
|  | size_t | iteration |
| ) |  |  | `[pure virtual]`

This event occurs just before the view & projection matrices are set for rendering into a shadow texture.

Remarks:
  You can use this event hook to perform some custom processing, such as altering the camera being used for rendering the light's view, including setting custom view & projection matrices if you want to perform an advanced shadow technique.

Note:
  This event will only be fired when texture shadows are in use.

Parameters:

  | light | Pointer to the light for which shadows are being rendered
  | camera | Pointer to the camera being used to render
  | iteration | For lights that use multiple shadow textures, the iteration number

virtual void Ogre::SceneManager::Listener::shadowTextureReceiverPreViewProj | ( | Light * | light,
|  | Frustum * | frustum |
| ) |  |  | `[pure virtual]`

This event occurs just before the view & projection matrices are set for re-rendering a shadow receiver.

Remarks:
  You can use this event hook to perform some custom processing, such as altering the projection frustum being used for rendering the shadow onto the receiver to perform an advanced shadow technique.

Note:
  This event will only be fired when texture shadows are in use.

Parameters:

  | light | Pointer to the light for which shadows are being rendered
  | frustum | Pointer to the projection frustum being used to project the shadow texture

virtual bool Ogre::SceneManager::Listener::sortLightsAffectingFrustum | ( | LightList & | lightList | ) | `[virtual]`

Hook to allow the listener to override the ordering of lights for the entire frustum.

Remarks:
  Whilst ordinarily lights are sorted per rendered object (

See also:
  MovableObject::queryLights), texture shadows adds another issue in that, given there is a finite number of shadow textures, we must choose which lights to render texture shadows from based on the entire frustum. These lights should always be listed first in every objects own list, followed by any other lights which will not cast texture shadows (either because they have shadow casting off, or there aren't enough shadow textures to service them).

  This hook allows you to override the detailed ordering of the lights per frustum. The default ordering is shadow casters first (which you must also respect if you override this method), and ordered by distance from the camera within those 2 groups. Obviously the closest lights with shadow casting enabled will be listed first. Only lights within the range of the frustum will be in the list.

Parameters:

  | lightList | The list of lights within range of the frustum which you may sort.

Returns:
  true if you sorted the list, false otherwise.

Definition at line 319 of file OgreSceneManager.h.

The documentation for this class was generated from the following file:

- OgreSceneManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:36:09 2009